﻿//
// 20130827
//
// code by ecat 
// KSP forum name: ecat
//
// License:
// released under CC BY-NC-SA 3.0
// Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
//

using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
//using System.Threading.Tasks;

using UnityEngine;
using MuMech;


namespace ecCoMAdjModule
{
    public class ecCoMAdjPart : PartModule
    {
//        MuMechServo parentRail;
        public Part parentRail;
        private Vector3 parentStartPos;
        private Quaternion parentStartRot;

        KSPActionParam actionActivate, actionDeactivate;

        [KSPField(isPersistant = true)]
        public float maxPosError = 0.004f;          // want better than 0.002 for non SAS corrected flight? 0.0001 is noise floor?
                                                    // Orig. Rail resolution appears near 0.01 !

        public int currentMovement;                 // 0 = none, positive value = plus, negative value = minus 
        public bool trackCoM = false;
        public float origRailSpeed = 0.3f;
        public int primaryAxis = -1;                // 0 == x, 1 == y, 2 == z, < 0 is a claibration state
        public int primaryDirection = 1;

        private static Vector3 lastAlmostEqualResult;
        private static float lastAmlostEqualAngle;

        public static bool VectorPosAlmostEqual(Vector3 v1, Vector3 v2, float precision, int ignoreAxis )
        {
            bool equal = true;

            lastAlmostEqualResult = v1 - v2;

            //if (Mathf.Abs(v1.x - v2.x) > precision) equal = false;
            //if (Mathf.Abs(v1.y - v2.y) > precision) equal = false;
            //if (Mathf.Abs(v1.z - v2.z) > precision) equal = false;

            if ( (ignoreAxis != 0) && (Mathf.Abs(lastAlmostEqualResult.x) > precision) ) equal = false;
            if ( (ignoreAxis != 1) && (Mathf.Abs(lastAlmostEqualResult.y) > precision) ) equal = false;
            if ( (ignoreAxis != 2) && (Mathf.Abs(lastAlmostEqualResult.z) > precision) ) equal = false;

            return equal;
        }

        public static bool QuaternionAngleAlmostEqual(Quaternion q1, Quaternion q2, float precisionDegrees)
        {
            bool equal = true;
            lastAmlostEqualAngle = Quaternion.Angle(q1, q2);             // Returns the angle in degrees between two rotations a and b.

            if (lastAmlostEqualAngle > precisionDegrees) equal = false;
            return equal;
        }

        public void debugPrintPart()
        { 
            try
            {
                try { Debug.Log("001 " + this.part.Actions);
                } catch{} 
                try { Debug.Log("002 " + this.part.ActivatesEvenIfDisconnected);
                } catch{} 
                try { Debug.Log("003 " + this.part.airlock);
                } catch{} 
                try { Debug.Log("004 " + this.part.angularDrag);
                } catch{} 
                try { Debug.Log("005 " + this.part.animation);
                } catch{} 
                try { Debug.Log("006 " + this.part.attachJoint);
                } catch{} try { Debug.Log("007 " + this.part.attachMethod);
                } catch{} try { Debug.Log("008 " + this.part.attachMode);
                } catch{} try { Debug.Log("009 " + this.part.attachNodes);
                } catch{} try { Debug.Log("010 " + this.part.attachRules);

                } catch{} try { Debug.Log("011 " + this.part.attRotation);
                } catch{} try { Debug.Log("012 " + this.part.audio);
                } catch{} try { Debug.Log("013 " + this.part.breakingForce);
                } catch{} try { Debug.Log("014 " + this.part.breakingTorque);
                } catch{} try { Debug.Log("015 " + this.part.buoyancy);
                } catch{} try { Debug.Log("016 " + this.part.CenterOfBuoyancy);
                } catch{} try { Debug.Log("017 " + this.part.children);
                } catch{} try { Debug.Log("018 " + this.part.childStageOffset);
                } catch{} try { Debug.Log("019 " + this.part.ClassID);
                } catch{} try { Debug.Log("020 " + this.part.ClassName);

                } catch{} try { Debug.Log("021 " + this.part.collider);
                } catch{} try { Debug.Log("022 " + this.part.collisionEnhancer);
                } catch{} try { Debug.Log("023 " + this.part.CoMOffset);
                } catch{} try { Debug.Log("024 " + this.part.constantForce);
                } catch{} try { Debug.Log("025 " + this.part.ConstructID);
                } catch{} try { Debug.Log("026 " + this.part.crashTolerance);
                } catch{} try { Debug.Log("027 " + this.part.CrewCapacity);
                } catch{} try { Debug.Log("028 " + this.part.currentCollisions);
                } catch{} try { Debug.Log("029 " + this.part.customPartData);
                } catch{} try { Debug.Log("030 " + this.part.defaultInverseStage);

                } catch{} try { Debug.Log("031 " + this.part.dragModel);
                } catch{} try { Debug.Log("032 " + this.part.dragModelType);
                } catch{} try { Debug.Log("033 " + this.part.dragReferenceVector);
                } catch{} try { Debug.Log("034 " + this.part.dynamicPressureAtm);
                } catch{} try { Debug.Log("035 " + this.part.editorCollision);
                } catch{} try { Debug.Log("036 " + this.part.editorLinks);
                } catch{} try { Debug.Log("037 " + this.part.Effects);
                } catch{} try { Debug.Log("038 " + this.part.enabled);
                } catch{} try { Debug.Log("039 " + this.part.Events);
                } catch{} try { Debug.Log("040 " + this.part.explosionPotential);

                } catch{} try { Debug.Log("041 " + this.part.Fields);
                } catch{} try { Debug.Log("042 " + this.part.flagURL);
                } catch{} try { Debug.Log("043 " + this.part.flightID);
                } catch{} try { Debug.Log("044 " + this.part.flightIntegrator);
                } catch{} try { Debug.Log("045 " + this.part.frozen);
                } catch{} try { Debug.Log("046 " + this.part.fuelCrossFeed);
                } catch{} try { Debug.Log("047 " + this.part.fuelLookupTargets);
                } catch{} try { Debug.Log("048 " + this.part.fxGroups);
                } catch{} try { Debug.Log("049 " + this.part.gameObject);
                } catch{} try { Debug.Log("050 " + this.part.GroundContact);

                } catch{} try { Debug.Log("051 " + this.part.hasHeiarchyModel);
                } catch{} try { Debug.Log("052 " + this.part.hasStagingIcon);
                } catch{} try { Debug.Log("053 " + this.part.hideFlags);
                } catch{} try { Debug.Log("054 " + this.part.highlightColor);
                } catch{} try { Debug.Log("055 " + this.part.highlightRecurse);
                } catch{} try { Debug.Log("056 " + this.part.highlightType);
                } catch{} try { Debug.Log("057 " + this.part.hingeJoint);
                } catch{} try { Debug.Log("058 " + this.part.initialVesselName);
                } catch{} try { Debug.Log("059 " + this.part.inStageIndex);
                } catch{} try { Debug.Log("060 " + this.part.internalModel);

                } catch{} try { Debug.Log("061 " + this.part.InternalModelName);
                } catch{} try { Debug.Log("062 " + this.part.inverseStage);
                } catch{} try { Debug.Log("063 " + this.part.isAttached);
                } catch{} try { Debug.Log("064 " + this.part.isClone);
                } catch{} try { Debug.Log("065 " + this.part.isConnected);
                } catch{} try { Debug.Log("066 " + this.part.isControllable);
                } catch{} try { Debug.Log("067 " + this.part.isControlSource);
                } catch{} try { Debug.Log("068 " + this.part.isMirrored);
                } catch{} try { Debug.Log("069 " + this.part.isPersistent);
                } catch{} try { Debug.Log("070 " + this.part.Landed);


                } catch{} try { Debug.Log("071 " + this.part.lastFuelRequestId);
                } catch{} try { Debug.Log("072 " + this.part.light);
                } catch{} try { Debug.Log("073 " + this.part.localRoot);
                } catch{} try { Debug.Log("074 " + this.part.manualStageOffset);
                } catch{} try { Debug.Log("075 " + this.part.mass);
                } catch{} try { Debug.Log("076 " + this.part.maximum_drag);
                } catch{} try { Debug.Log("077 " + this.part.maxTemp);
                } catch{} try { Debug.Log("078 " + this.part.minimum_drag);
                } catch{} try { Debug.Log("079 " + this.part.mirrorAxis);
                } catch{} try { Debug.Log("080 " + this.part.mirrorRefAxis);

                } catch{} try { Debug.Log("081 " + this.part.mirrorVector);
                } catch{} try { Debug.Log("082 " + this.part.missionID);
                } catch{} try { Debug.Log("083 " + this.part.Modules);
                } catch{} try { Debug.Log("084 " + this.part.name);
                } catch{} try { Debug.Log("085 " + this.part.networkView);
                } catch{} try { Debug.Log("086 " + this.part.NoCrossFeedNodeKey);
                } catch{} try { Debug.Log("087 " + this.part.OnEditorAttach);
                } catch{} try { Debug.Log("088 " + this.part.OnEditorDestroy);
                } catch{} try { Debug.Log("089 " + this.part.OnEditorDetach);
                } catch{} try { Debug.Log("090 " + this.part.OnJustAboutToBeDestroyed);

                } catch{} try { Debug.Log("091 " + this.part.orbit);
                } catch{} try { Debug.Log("092 " + this.part.orgPos);
                } catch{} try { Debug.Log("093 " + this.part.orgRot);
                } catch{} try { Debug.Log("094 " + this.part.originalStage);
                } catch{} try { Debug.Log("095 " + this.part.packed);
                } catch{} try { Debug.Log("096 " + this.part.parent);
                } catch{} try { Debug.Log("097 " + this.part.partBuoyancy);
                } catch{} try { Debug.Log("098 " + this.part.particleEmitter);
                } catch{} try { Debug.Log("099 " + this.part.particleSystem);
                } catch{} try { Debug.Log("100 " + this.part.partInfo);

                } catch{} try { Debug.Log("101 " + this.part.partName);
                } catch{} try { Debug.Log("102 " + this.part.physicalSignificance);
                } catch{} try { Debug.Log("103 " + this.part.PhysicsSignificance);
                } catch{} try { Debug.Log("104 " + this.part.potentialParent);
                } catch{} try { Debug.Log("105 " + this.part.protoModuleCrew);
                } catch{} try { Debug.Log("106 " + this.part.protoPartRef);
                } catch{} try { Debug.Log("107 " + this.part.protoPartSnapshot);
                } catch{} try { Debug.Log("108 " + this.part.renderer);
                } catch{} try { Debug.Log("109 " + this.part.rescaleFactor);
                } catch{} try { Debug.Log("110 " + this.part.Resources);

                } catch{} try { Debug.Log("111 " + this.part.ResumeState);
                } catch{} try { Debug.Log("112 " + this.part.rigidbody);
                } catch{} try { Debug.Log("113 " + this.part.Rigidbody);
                } catch{} try { Debug.Log("114 " + this.part.scaleFactor);
                } catch{} try { Debug.Log("115 " + this.part.Splashed);
                } catch{} try { Debug.Log("116 " + this.part.srfAttachNode);
                } catch{} try { Debug.Log("117 " + this.part.stackIcon);
                } catch{} try { Debug.Log("118 " + this.part.stackIconGrouping);
                } catch{} try { Debug.Log("119 " + this.part.stackSymmetry);
                } catch{} try { Debug.Log("120 " + this.part.stageAfter);

                } catch{} try { Debug.Log("121 " + this.part.stageBefore);
                } catch{} try { Debug.Log("122 " + this.part.stageOffset);
                } catch{} try { Debug.Log("123 " + this.part.stagingIcon);
                } catch{} try { Debug.Log("124 " + this.part.started);
                } catch{} try { Debug.Log("125 " + this.part.State);
                } catch{} try { Debug.Log("126 " + this.part.staticPressureAtm);
                } catch{} try { Debug.Log("127 " + this.part.surfaceAreas);
                } catch{} try { Debug.Log("128 " + this.part.symmetryCounterparts);
                } catch{} try { Debug.Log("129 " + this.part.symmetryMode);
                } catch{} try { Debug.Log("130 " + this.part.tag);

                } catch{} try { Debug.Log("131 " + this.part.temperature);
                } catch{} try { Debug.Log("132 " + this.part.terrainCollider);
                } catch{} try { Debug.Log("133 " + this.part.topNode);
                } catch{} try { Debug.Log("134 " + this.part.transform);
                } catch{} try { Debug.Log("135 " + this.part.uid);
                } catch{} try { Debug.Log("136 " + this.part.useGUILayout);
                } catch{} try { Debug.Log("137 " + this.part.vel);
                } catch{} try { Debug.Log("138 " + this.part.vessel);
                } catch{} try { Debug.Log("139 " + this.part.vesselType);
                } catch{} try { Debug.Log("140 " + this.part.WaterContact);
                } catch{}

                if (this.part as LiquidEngine != null)
                {
                     try { Debug.Log("LiquidEngine");

                    } catch{} try { Debug.Log("1001 " + (this.part as LiquidEngine).draperPoint);
                    } catch{} try { Debug.Log("1002 " + (this.part as LiquidEngine).exhaustDamage);
                    } catch{} try { Debug.Log("1003 " + (this.part as LiquidEngine).fallbackGimbalName);
                    } catch{} try { Debug.Log("1004 " + (this.part as LiquidEngine).fuelConsumption);
                    } catch{} try { Debug.Log("1005 " + (this.part as LiquidEngine).gimbalAngleH);
                    } catch{} try { Debug.Log("1006 " + (this.part as LiquidEngine).gimbalAngleV);
                    } catch{} try { Debug.Log("1007 " + (this.part as LiquidEngine).gimbalRange);
                    } catch{} try { Debug.Log("1008 " + (this.part as LiquidEngine).heatProduction);
                    } catch{} try { Debug.Log("1009 " + (this.part as LiquidEngine).maxThrust);
                    } catch{} try { Debug.Log("1010 " + (this.part as LiquidEngine).minThrust);

                    } catch{} try { Debug.Log("1011 " + (this.part as LiquidEngine).ThermalAnim);
                    } catch{} try { Debug.Log("1012 " + (this.part as LiquidEngine).thrustVector);
                    } catch{} try { Debug.Log("1013 " + (this.part as LiquidEngine).thrustVectoringCapable);
                    } catch{}
                }

                if (this.part as LiquidFuelEngine != null)
                {
                     try { Debug.Log("LiquidFuelEngine");
                    } catch{} try { Debug.Log("2001 " + (this.part as LiquidFuelEngine).draperPoint);
                    } catch{} try { Debug.Log("2002 " + (this.part as LiquidFuelEngine).exhaustDamage);
                    } catch{} try { Debug.Log("2003 " + (this.part as LiquidFuelEngine).fallbackGimbalName);
                    } catch{} try { Debug.Log("2004 " + (this.part as LiquidFuelEngine).fuelConsumption);
                    } catch{} try { Debug.Log("2005 " + (this.part as LiquidFuelEngine).gimbalAngleH);
                    } catch{} try { Debug.Log("2006 " + (this.part as LiquidFuelEngine).gimbalAngleV);
                    } catch{} try { Debug.Log("2007 " + (this.part as LiquidFuelEngine).gimbalRange);
                    } catch{} try { Debug.Log("2008 " + (this.part as LiquidFuelEngine).heatProduction);
                    } catch{} try { Debug.Log("2009 " + (this.part as LiquidFuelEngine).maxThrust);
                    } catch{} try { Debug.Log("2010 " + (this.part as LiquidFuelEngine).minThrust);

                    } catch{} try { Debug.Log("2011 " + (this.part as LiquidFuelEngine).ThermalAnim);
                    } catch{} try { Debug.Log("2012 " + (this.part as LiquidFuelEngine).thrustVector);
                    } catch{} try { Debug.Log("2013 " + (this.part as LiquidFuelEngine).thrustVectoringCapable);
                    }
                     catch { }
                }
            }
            catch { }
        }

        //
        // Start States
        //  None = 0, Editor = 1, PreLaunch = 2, Landed = 4, Docked = 8,
        //  Flying = 16, Splashed = 32, SubOrbital = 64, Orbital = 128
        //
        public override void OnStart(StartState state)
        {
            base.OnStart(state);

// debugPrintPart();

            try
            {
                actionActivate = new KSPActionParam(0, KSPActionType.Activate);
                actionDeactivate = new KSPActionParam(0, KSPActionType.Deactivate);
            }
            catch { Debug.Log("ecCoMAdj action create fail"); }

            UnityEngine.Vector3 debugCoM; debugCoM.x = debugCoM.y = debugCoM.z = -1.0f;      // = { -1, -1, -1 };
            try { debugCoM = FlightGlobals.ActiveVessel.localCoM; }
            catch { Debug.Log("ecCoMAdj FlightGlobals.ActiveVessel fail. This is not unexpected while in the Editor."); }

            Vector3 coMOffset; coMOffset.x = coMOffset.y = coMOffset.z = -1.0f;     // = { -2, -2, -2 };
            try { coMOffset = this.part.CoMOffset; }
            catch { Debug.Log("ecCoMAdj part.CoMOffset fail"); }        // orgPos;

//            maxPosError = 0.005f;
            Debug.Log("ecCoMAdj maxPosError " + maxPosError);
//            trackCoM = false;
                    
            currentMovement = 0;

//            GUICoMTrkOff();

            SetGUICoMTrkEvents();

            Debug.Log("ecCoMAdj StartState " + (int)state );

            if (state != StartState.None && state != StartState.Editor)
            {
                Debug.Log("ecCoMAdj Starting Part data1 P() R() (" + this.part.orgPos.x + ", " + this.part.orgPos.y + ", " + this.part.orgPos.z + ") (" + this.part.orgRot.x + ", " + this.part.orgRot.y + ", " + this.part.orgRot.z +
                    ")");

                Debug.Log("ecCoMAdj Starting CoM data1 V() P() (" + debugCoM.x + ", " + debugCoM.y + ", " + debugCoM.z + ") (" + coMOffset.x + ", " + coMOffset.y + ", " + coMOffset.z +
                    ")");

                //debugCoM = FlightGlobals.ActiveVessel.localCoM;

                //debugCoM = FlightGlobals.ActiveVessel.findLocalCenterOfMass();

                //Vector3 coMOffset2 = this.part.orgPos;

                //Debug.Log("ecCoMAdj Starting CoM data2 V() P() (" + debugCoM.x + ", " + debugCoM.y + ", " + debugCoM.z + ") (" + coMOffset2.x + ", " + coMOffset2.y + ", " + coMOffset2.z +
                //    ")");

                //Debug.Log("ecCoMAdj Starting Parent partName, ClassName " + this.part.parent.partName + ", " + this.part.parent.ClassName);
                //Debug.Log("ecCoMAdj Starting Parent Q rotation (" + this.part.parent.orgRot.x + ", " + this.part.parent.orgRot.y + ", " + this.part.parent.orgRot.z + ")");
                //Debug.Log("ecCoMAdj Starting Parent E rotation (" + this.part.parent.orgRot.eulerAngles.x + ", " + this.part.parent.orgRot.eulerAngles.y + ", " + this.part.parent.orgRot.eulerAngles.z + ")");

                //Debug.Log("ecCoMAdj Starting Parent position " + this.part.parent.orgPos + ")");
                //Debug.Log("ecCoMAdj Starting Parent ref. transform (" + this.part.parent.GetReferenceTransform() + ")");

                if (this.part.parent.ClassName == "MuMechServo")
                {
                    parentRail = this.part.parent;                                  // need to check it is still attached when in update?
                    origRailSpeed = (parentRail as MuMechServo).keyTranslateSpeed;
                    parentStartPos = parentRail.orgPos;
                    parentStartRot = parentRail.orgRot;
                }
                else
                    parentRail = null;

            }
        }


        private int MovementDir = 0;                // -1 == negative direction, 0 = no movement, 1 == positive direction
        private int SkipCalibrateCheck = 0;

        private Vector3 LastPartPos;

        private void SwitchMovementDir()
        {
            if (MovementDir < 0)
                MovementDir = 1;
            else
                MovementDir = -1;
        }

        public void FixedUpdate()
        {
            // try to fix rocket engine in editor... didn't work            base.OnFixedUpdate();

            //if (HighLogic.LoadedSceneIsEditor)
            //    return;
            if (FlightGlobals.ActiveVessel != this.vessel)                 ///  vessel)
                return;

            if ((parentRail == null) || (this.part.parent == null))        // I guess part.parent == null after a disconnect?
                return;

            if ((parentRail as MuMechServo) == null)
                return;

            if (trackCoM == false)
            {
                //Vector3 vesselCoMdb = FlightGlobals.ActiveVessel.findLocalCenterOfMass();
                //Vector3 partCoMdb = this.part.orgPos;                     // if org is offset from 0 we need to deal with it somehow
                //                Debug.Log("ecCoMAdj Track Off V() P() " + " (" + vesselCoMdb.x + ", " + vesselCoMdb.y + ", " + vesselCoMdb.z + ") (" + partCoMdb.x + ", " + partCoMdb.y + ", " + partCoMdb.z + ")");

                if (currentMovement != 0)
                    cancelMovement();                                       // without this a currently active move command could run on, this is not what we want 
                (parentRail as MuMechServo).keyTranslateSpeed = origRailSpeed;
                return;
            }

            if ((parentRail as MuMechServo).isRotationLock == true)
                return;

            Vector3 vesselCoM = FlightGlobals.ActiveVessel.findLocalCenterOfMass();
            Vector3 partPos = this.part.orgPos;                     // if org is offset from 0 we need to deal with it somehow
            float posError = 0.0f;
            Vector3 deltaPos = Vector3.zero;

//            Debug.Log("ecCoMAdj VCoM() PPos() " + " (" + vesselCoM.x + ", " + vesselCoM.y + ", " + vesselCoM.z + ") (" + partPos.x + ", " + partPos.y + ", " + partPos.z + ")");

            if (primaryAxis < 0)
            {
                if (primaryAxis == -2)
                {
                    deltaPos = LastPartPos - partPos;

                    int axisIdx = 0;
                    int maxAxis = 0;
                    float maxDelta = Math.Abs(deltaPos[axisIdx]);

                    axisIdx++;
                    if (Math.Abs(deltaPos[axisIdx]) > maxDelta)
                    {
                        maxDelta = Math.Abs(deltaPos[axisIdx]);
                        maxAxis = 1;
                    }

                    axisIdx++;
                    if (Math.Abs(deltaPos[axisIdx]) > maxDelta)
                    {
                        maxDelta = Math.Abs(deltaPos[axisIdx]);
                        maxAxis = 2;
                    }

                    if (maxDelta > 0.001)
                    {
                        primaryAxis = maxAxis;
                        Debug.Log("ecCoMAdj Got pAxis. maxDelta, L-V, P-V " + maxDelta + " " + Math.Abs(LastPartPos[primaryAxis] - vesselCoM[primaryAxis]) + " " +
                            Math.Abs(partPos[primaryAxis] - vesselCoM[primaryAxis]));

                        if (Math.Abs(LastPartPos[primaryAxis] - vesselCoM[primaryAxis]) > Math.Abs(partPos[primaryAxis] - vesselCoM[primaryAxis]))
                        {
                            if( partPos[primaryAxis] > vesselCoM[primaryAxis] )
                                primaryDirection = -MovementDir;
                            else
                                primaryDirection = MovementDir;
                        }
                        else
                            if (Math.Abs(LastPartPos[primaryAxis] - vesselCoM[primaryAxis]) < Math.Abs(partPos[primaryAxis] - vesselCoM[primaryAxis]))
                            {
                                if (partPos[primaryAxis] > vesselCoM[primaryAxis])
                                    primaryDirection = MovementDir;
                                else
                                    primaryDirection = -MovementDir;
                            }
                            else
                                primaryAxis = -1;       // this should never happen as a 'step' should always have been taken by this point.

                        Debug.Log("ecCoMAdj Got pAxis. pDir, LastPartPos, partPos, deltaPos " + primaryAxis + " " + primaryDirection + " (" +
                            LastPartPos.x + ", " + LastPartPos.y + ", " + LastPartPos.z + ")(" +
                            partPos.x + ", " + partPos.y + ", " + partPos.z + ")(" +
                            deltaPos.x + ", " + deltaPos.y + ", " + deltaPos.z + ")");
                    }
                    else primaryAxis = -1;

                }

                if (primaryAxis == -1)
                {
                    LastPartPos = partPos;
                    primaryAxis = -2;
                    SwitchMovementDir();
                    (parentRail as MuMechServo).keyTranslateSpeed = 0.3f;
                    Debug.Log("ecCoMAdj primaryAxis was == -1, Dir, primaryAxis,  " + MovementDir + " " + primaryAxis + " " + posError + " " + (parentRail as MuMechServo).keyTranslateSpeed);

                }
            }
            else
            {
                LastPartPos = partPos;                                                      // may not need this

                if( ++SkipCalibrateCheck >= 10 )
                {
                    SkipCalibrateCheck = 0;
                    bool needRecalibrate = false;

                    if (!VectorPosAlmostEqual(parentStartPos, parentRail.orgPos, 0.01f, primaryAxis))
                    {
                        Debug.Log("ecCoMAdj Parent Position Changed (" + lastAlmostEqualResult.x + ", " + lastAlmostEqualResult.y + ", " + lastAlmostEqualResult.z + ")");
                        parentStartPos = parentRail.orgPos;                                     // make a new start
                        needRecalibrate = true;
                    }

                    if (!QuaternionAngleAlmostEqual(parentStartRot, parentRail.orgRot, 0.1f))
                    {
                        Debug.Log("ecCoMAdj Parent Rotation Changed " + lastAmlostEqualAngle);
                        parentStartRot = parentRail.orgRot;                                     // make a new start
                        needRecalibrate = true;
                    }

                    if (needRecalibrate)
                    {
                        primaryAxis = -1;
                        return;
                    }
                }

                posError = partPos[primaryAxis] - vesselCoM[primaryAxis];
                if (Math.Abs(posError) > 0.0055f)
                    (parentRail as MuMechServo).keyTranslateSpeed = 0.3f;
                else
                    if (Math.Abs(posError) > 0.00055f)
                        (parentRail as MuMechServo).keyTranslateSpeed = 0.03f;
                    else
                        (parentRail as MuMechServo).keyTranslateSpeed = 0.003f;

                if (posError < 0.0f)
                    MovementDir = -primaryDirection;                 //-1;
                if (posError > 0.0f)
                    MovementDir = primaryDirection;                   //1;

                maxPosError = 0.0001f;

                if (Math.Abs(posError) < maxPosError)
                    MovementDir = 0;

            }

//            Debug.Log("ecCoMAdj Dir, primaryAxis, posError, speed " + MovementDir + " " + primaryAxis + " " + posError + " " + (parentRail as MuMechServo).keyTranslateSpeed);

            if (MovementDir > 0 )
            {
                plusMovement();
            }
            else if (MovementDir < 0 )
            {
                minusMovement();
            }
            else
            {
                cancelMovement();
            }
        }


        void plusMovement()
        {
            currentMovement = 1;
            (parentRail as MuMechServo).MoveMinusAction(actionDeactivate);
            (parentRail as MuMechServo).MovePlusAction(actionActivate);
        }


        void minusMovement()
        {
            currentMovement = -1;
            (parentRail as MuMechServo).MovePlusAction(actionDeactivate);
            (parentRail as MuMechServo).MoveMinusAction(actionActivate);
        }


        public void cancelMovement()
        {
            currentMovement = 0;
            (parentRail as MuMechServo).MovePlusAction(actionDeactivate);
            (parentRail as MuMechServo).MoveMinusAction(actionDeactivate);
        }



        [KSPAction("Toggle CoM Trk")]
        public void ToggleCoMTrk(KSPActionParam param)
        {
            if (trackCoM)
                GUICoMTrkOff();
            else
                GUICoMTrkOn();
        }

        [KSPAction("CoM Trk Off*")]
        public void CoMTrkOff(KSPActionParam param)
        {
            GUICoMTrkOff();
        }

        [KSPAction("CoM Trk On")]
        public void CoMTrkOn(KSPActionParam param)
        {
            GUICoMTrkOn();
        }

        // NB, initialise bool from OnStart by making this call so GUI actives are set correctly
        //
        [KSPEvent(guiActive = true, guiName = "CoM Trk Off*", active = false)]
        public void GUICoMTrkOff()
        {
            trackCoM = false;
            SetGUICoMTrkEvents();
        }

        [KSPEvent(guiActive = true, guiName = "CoM Trk On")]
        public void GUICoMTrkOn()
        {
            trackCoM = true;
            SetGUICoMTrkEvents();

        }

        public void SetGUICoMTrkEvents()
        {
            if (trackCoM == true)
            {
                Events["GUICoMTrkOn"].active = false;
                Events["GUICoMTrkOff"].active = true;
            }
            else
            {
                primaryAxis = -1;                       // reset axis on disable event
                Events["GUICoMTrkOn"].active = true;
                Events["GUICoMTrkOff"].active = false;
            }
        }

    }

}
